"use strict";
/********************************************************************************
 * Copyright (C) 2017 TypeFox and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var node_1 = require("@devpodio/languages/lib/node");
var common_1 = require("../common");
var utils_1 = require("@devpodio/process/lib/node/utils");
var PythonContribution = /** @class */ (function (_super) {
    __extends(PythonContribution, _super);
    function PythonContribution() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.id = common_1.PYTHON_LANGUAGE_ID;
        _this.name = common_1.PYTHON_LANGUAGE_NAME;
        return _this;
    }
    PythonContribution.prototype.start = function (clientConnection) {
        var command = 'python';
        var args = ['-m', 'pyls'];
        var pythonLsCommand = process.env.PYTHON_LS_COMMAND;
        if (pythonLsCommand) {
            command = pythonLsCommand;
            args = utils_1.parseArgs(process.env.PYTHON_LS_ARGS || '');
        }
        var serverConnection = this.createProcessStreamConnection(command, args, this.getSpawnOptions());
        this.forward(clientConnection, serverConnection);
    };
    PythonContribution.prototype.getSpawnOptions = function () {
        return undefined;
    };
    PythonContribution.prototype.onDidFailSpawnProcess = function (error) {
        _super.prototype.onDidFailSpawnProcess.call(this, error);
        console.error('Python language server cannot be started.');
        console.error("Make sure `pyls` is installed: e.g. `pip install 'python-language-server[all]'`");
    };
    PythonContribution = __decorate([
        inversify_1.injectable()
    ], PythonContribution);
    return PythonContribution;
}(node_1.BaseLanguageServerContribution));
exports.PythonContribution = PythonContribution;
//# sourceMappingURL=python-contribution.js.map